# Trigger 

---
## Action

Ação a ser registrada no funifier quando executar um evento.

### Parameters

** Atributos (Opcional)**

* **name**: String - name of attribute
* **type**: Option - type of attribute
* **function**: String - function that dynamically capture the value of the attribute

#### Exemplo

```javascript
 return Funifier._$('#idade').val();
```
---

## Event

Tipo de evento a ser monitorado

---
## Selector

Elemento HTML que irá ser mapeado o evento

---

## Page

Página (s) que irá acompanhar o evento

---

## Pre Script (Optional)

Função realizada antes elemento HTML ser mapeado (vincular)

### Javascript available variables:
- element: DOM element
- trigger: object
    * **_id**: String
    * **name**: String
    * **actions**: Array
    * **trigger**: String ['click','pageview',...]
    * **selector**: String
    * **page**: String
    * **pre_script**: String
    * **post_script**: String
    * **pre_validation_script**: String

#### Example

Caso o elemento seja processado por ajax, pode criar uma função para chamar a função "Track" manualmente

```javascript
Funifier ._ $ ('body'). On ('click', trigger.selector, function () {
    Funifier.track ({action: trigger._id, TRIGGER_TYPE: 'TRIGGER_HTML'});
});
```

##### Nota 1: Quando estamos usando o id do "Track", deve informar o atributo tipo de Track como "TRIGGER_HTML" na função "Funifier.track ()"

##### Nota 2: Se você fizer um "track" manualmente, você deve retornar falso em pré validação a fim de evitar um comportamento inesperado, por exemplo registrar "track" mais de uma vez

---

# Pre Validation (Optional)

Função de validação realizada antes de ser registrada "track" no funifier. Esperar o retorno como um boolean, caso o retorno é "falso", cancelar o processo e não serão registrados a "faixa" no Funifier.

### Javascript available variables:
- element: DOM element
- trigger: object
    * **_id**: String
    * **name**: String
    * **actions**: Array
    * **trigger**: String ['click','pageview',...]
    * **selector**: String
    * **page**: String
    * **pre_script**: String
    * **post_script**: String
    * **pre_validation_script**: String

#### Exemplo

```javascript
var value = Funifier._$('# name').val();
if(value.length > 0) {
    // Blank field will not be made the track
    return false;
}
return true;
```

---

# Post Script (Optional)

Function performed after the track.

### Javascript available variables:
- element: DOM element
- trigger: object
    * **_id**: String
    * **name**: String
    * **actions**: Array
    * **trigger**: String ['click','pageview',...]
    * **selector**: String
    * **page**: String
    * **pre_script**: String
    * **post_script**: String
    * **pre_validation_script**: String

#### Exemplo

```javascript
    alert('action tracked');
```

##### Nota: Em alguns casos, estas funções não podem ser executadas, dependem do contexto, por exemplo: redirecionamento da página.

---

# Run only client

If the event is "page view" can be done "Track" manually

# Name (Optional)
Nome de referência no estúdio